// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 1 "asm-parse.yy"
                                                       // -*- C++ -*-
//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//

//
// WARNING: Generated file, do not edit by hand!
//


#include <string>

#include "common.hh"

#include "inst/label.hh"
#include "inst/program_builder.hh"
#include "inst/exp.hh"
#include "inst/register.hh"
#include "inst/all.hh"

#include "parse/libparse.hh"

using namespace inst;

#line 80 "./asm-parse.cc"


#include "asm-parse.hh"

// Second part of user prologue.
#line 65 "asm-parse.yy"

#include "parse/asm-scan.hh"

#line 90 "./asm-parse.cc"



#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

namespace yy {
#line 183 "./asm-parse.cc"

  /// Build a parser object.
  parser::parser (std::string &filename_yyarg, inst::ProgramBuilder &program_builder_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      filename (filename_yyarg),
      program_builder (program_builder_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/

  // basic_symbol.
  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value (that.value)
    , location (that.location)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_MOVE_REF (location_type) l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_RVREF (value_type) v, YY_RVREF (location_type) l)
    : Base (t)
    , value (YY_MOVE (v))
    , location (YY_MOVE (l))
  {}


  template <typename Base>
  parser::symbol_kind_type
  parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  template <typename Base>
  bool
  parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    value = YY_MOVE (s.value);
    location = YY_MOVE (s.location);
  }

  // by_kind.
  parser::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  parser::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  parser::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

  parser::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}



  void
  parser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  parser::symbol_kind_type
  parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }


  parser::symbol_kind_type
  parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }



  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_kind_type
  parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.value), YY_MOVE (that.location))
  {
#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.value), YY_MOVE (that.location))
  {
    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    switch (yysym.kind ())
    {
      case symbol_kind::S_LABEL: // "label"
#line 77 "asm-parse.yy"
                    { delete (yysym.value.id); }
#line 396 "./asm-parse.cc"
        break;

      case symbol_kind::S_LABEL_DEF: // "label definition"
#line 78 "asm-parse.yy"
                    { delete (yysym.value.id); }
#line 402 "./asm-parse.cc"
        break;

      case symbol_kind::S_STRING: // "string"
#line 75 "asm-parse.yy"
                    { delete (yysym.value.s); }
#line 408 "./asm-parse.cc"
        break;

      default:
        break;
    }
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        switch (yykind)
    {
      case symbol_kind::S_INTEGER: // "integer"
#line 81 "asm-parse.yy"
                 { debug_stream () << (yysym.value.i); }
#line 436 "./asm-parse.cc"
        break;

      case symbol_kind::S_STRING: // "string"
#line 80 "asm-parse.yy"
                 { debug_stream () << *(yysym.value.s); }
#line 442 "./asm-parse.cc"
        break;

      case symbol_kind::S_REGISTER: // "register"
#line 80 "asm-parse.yy"
                 { debug_stream () << *(yysym.value.reg); }
#line 448 "./asm-parse.cc"
        break;

      default:
        break;
    }
        yyo << ')';
      }
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 52 "asm-parse.yy"
{
  yyla.location.begin.filename = yyla.location.end.filename = &filename;
}

#line 572 "./asm-parse.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* If YYLEN is nonzero, implement the default value of the
         action: '$$ = $1'.  Otherwise, use the top of the stack.

         Otherwise, the following line sets YYLHS.VALUE to garbage.
         This behavior is undocumented and Bison users should not rely
         upon it.  */
      if (yylen)
        yylhs.value = yystack_[yylen - 1].value;
      else
        yylhs.value = yystack_[0].value;

      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 7: // data: "label definition"
#line 204 "asm-parse.yy"
{ program_builder.define_data_label(*(yystack_[0].value.id)); }
#line 710 "./asm-parse.cc"
    break;

  case 8: // data: ".space" "integer"
#line 208 "asm-parse.yy"
{ program_builder.add_space((yystack_[0].value.i)); }
#line 716 "./asm-parse.cc"
    break;

  case 9: // data: ".byte" "integer"
#line 212 "asm-parse.yy"
{ program_builder.add_byte((yystack_[0].value.i)); }
#line 722 "./asm-parse.cc"
    break;

  case 10: // data: ".half" "integer"
#line 215 "asm-parse.yy"
{ program_builder.add_half((yystack_[0].value.i)); }
#line 728 "./asm-parse.cc"
    break;

  case 11: // data: ".word" "integer"
#line 218 "asm-parse.yy"
{ program_builder.add_word((yystack_[0].value.i)); }
#line 734 "./asm-parse.cc"
    break;

  case 12: // data: ".word" "label"
#line 220 "asm-parse.yy"
{ program_builder.add_word(new LabelExp(*(yystack_[0].value.id))); }
#line 740 "./asm-parse.cc"
    break;

  case 13: // data: ".ascii" "string"
#line 223 "asm-parse.yy"
{ program_builder.add_ascii((yystack_[0].value.s)); }
#line 746 "./asm-parse.cc"
    break;

  case 14: // data: ".asciiz" "string"
#line 225 "asm-parse.yy"
{ program_builder.add_asciiz((yystack_[0].value.s)); }
#line 752 "./asm-parse.cc"
    break;

  case 17: // instruction: "label definition"
#line 235 "asm-parse.yy"
{ program_builder.define_inst_label(*(yystack_[0].value.id)); }
#line 758 "./asm-parse.cc"
    break;

  case 18: // instruction: "add" "register" "," "register" "," "register"
#line 239 "asm-parse.yy"
{ program_builder.add_add((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 768 "./asm-parse.cc"
    break;

  case 19: // instruction: "add" "register" "," "register"
#line 245 "asm-parse.yy"
{ program_builder.add_add((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 777 "./asm-parse.cc"
    break;

  case 20: // instruction: "add" "register" "," "register" "," exp
#line 250 "asm-parse.yy"
{ program_builder.add_addi((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 786 "./asm-parse.cc"
    break;

  case 21: // instruction: "add" "register" "," exp
#line 255 "asm-parse.yy"
{ program_builder.add_addi((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 794 "./asm-parse.cc"
    break;

  case 22: // instruction: "addu" "register" "," "register" "," "register"
#line 259 "asm-parse.yy"
{ program_builder.add_addu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 804 "./asm-parse.cc"
    break;

  case 23: // instruction: "addu" "register" "," "register"
#line 265 "asm-parse.yy"
{ program_builder.add_addu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 813 "./asm-parse.cc"
    break;

  case 24: // instruction: "addu" "register" "," "register" "," exp
#line 270 "asm-parse.yy"
{ program_builder.add_addiu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 822 "./asm-parse.cc"
    break;

  case 25: // instruction: "addu" "register" "," exp
#line 275 "asm-parse.yy"
{ program_builder.add_addiu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 830 "./asm-parse.cc"
    break;

  case 26: // instruction: "addi" "register" "," "register" "," exp
#line 279 "asm-parse.yy"
{ program_builder.add_addi((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 839 "./asm-parse.cc"
    break;

  case 27: // instruction: "addi" "register" "," exp
#line 284 "asm-parse.yy"
{ program_builder.add_addi((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 847 "./asm-parse.cc"
    break;

  case 28: // instruction: "addiu" "register" "," "register" "," exp
#line 288 "asm-parse.yy"
{ program_builder.add_addiu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 856 "./asm-parse.cc"
    break;

  case 29: // instruction: "addiu" "register" "," exp
#line 293 "asm-parse.yy"
{ program_builder.add_addiu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 864 "./asm-parse.cc"
    break;

  case 30: // instruction: "sub" "register" "," "register" "," "register"
#line 297 "asm-parse.yy"
{ program_builder.add_sub((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 874 "./asm-parse.cc"
    break;

  case 31: // instruction: "sub" "register" "," "register"
#line 303 "asm-parse.yy"
{ program_builder.add_sub((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 883 "./asm-parse.cc"
    break;

  case 32: // instruction: "sub" "register" "," "register" "," exp
#line 308 "asm-parse.yy"
{ program_builder.add_addi((yystack_[4].value.reg), (yystack_[2].value.reg), new OpExp(new IntExp(0), OpExp::sub, (yystack_[0].value.exp)));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 892 "./asm-parse.cc"
    break;

  case 33: // instruction: "subu" "register" "," "register" "," "register"
#line 313 "asm-parse.yy"
{ program_builder.add_subu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 902 "./asm-parse.cc"
    break;

  case 34: // instruction: "subu" "register" "," "register"
#line 319 "asm-parse.yy"
{ program_builder.add_subu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 911 "./asm-parse.cc"
    break;

  case 35: // instruction: "subu" "register" "," "register" "," exp
#line 324 "asm-parse.yy"
{ program_builder.add_addiu((yystack_[4].value.reg), (yystack_[2].value.reg), new OpExp(new IntExp(0), OpExp::sub, (yystack_[0].value.exp)));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 920 "./asm-parse.cc"
    break;

  case 36: // instruction: "neg" "register" "," "register"
#line 329 "asm-parse.yy"
{ program_builder.add_sub((yystack_[2].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 929 "./asm-parse.cc"
    break;

  case 37: // instruction: "neg" "register"
#line 334 "asm-parse.yy"
{ program_builder.add_sub((yystack_[0].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
#line 937 "./asm-parse.cc"
    break;

  case 38: // instruction: "negu" "register" "," "register"
#line 338 "asm-parse.yy"
{ program_builder.add_subu((yystack_[2].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 946 "./asm-parse.cc"
    break;

  case 39: // instruction: "negu" "register"
#line 343 "asm-parse.yy"
{ program_builder.add_subu((yystack_[0].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
#line 954 "./asm-parse.cc"
    break;

  case 40: // instruction: "abs" "register" "," "register"
#line 347 "asm-parse.yy"
{ program_builder.add_abs((yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 963 "./asm-parse.cc"
    break;

  case 41: // instruction: "abs" "register"
#line 352 "asm-parse.yy"
{ program_builder.add_abs((yystack_[0].value.reg), (yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
#line 971 "./asm-parse.cc"
    break;

  case 42: // instruction: "mul" "register" "," "register" "," "register"
#line 356 "asm-parse.yy"
{ program_builder.add_mul((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 981 "./asm-parse.cc"
    break;

  case 43: // instruction: "mul" "register" "," "register"
#line 362 "asm-parse.yy"
{ program_builder.add_mul((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 990 "./asm-parse.cc"
    break;

  case 44: // instruction: "mul" "register" "," "register" "," exp
#line 367 "asm-parse.yy"
{ program_builder.add_mul((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 999 "./asm-parse.cc"
    break;

  case 45: // instruction: "div" "register" "," "register"
#line 372 "asm-parse.yy"
{ program_builder.add_div((yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1008 "./asm-parse.cc"
    break;

  case 46: // instruction: "div" "register" "," "register" "," "register"
#line 377 "asm-parse.yy"
{ program_builder.add_div((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1018 "./asm-parse.cc"
    break;

  case 47: // instruction: "div" "register" "," "register" "," exp
#line 383 "asm-parse.yy"
{ program_builder.add_div((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1027 "./asm-parse.cc"
    break;

  case 48: // instruction: "divu" "register" "," "register"
#line 388 "asm-parse.yy"
{ program_builder.add_divu((yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1036 "./asm-parse.cc"
    break;

  case 49: // instruction: "divu" "register" "," "register" "," "register"
#line 393 "asm-parse.yy"
{ program_builder.add_divu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1046 "./asm-parse.cc"
    break;

  case 50: // instruction: "divu" "register" "," "register" "," exp
#line 399 "asm-parse.yy"
{ program_builder.add_divu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1055 "./asm-parse.cc"
    break;

  case 51: // instruction: "rem" "register" "," "register" "," "register"
#line 404 "asm-parse.yy"
{ program_builder.add_rem((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1065 "./asm-parse.cc"
    break;

  case 52: // instruction: "rem" "register" "," "register"
#line 410 "asm-parse.yy"
{ program_builder.add_rem((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1074 "./asm-parse.cc"
    break;

  case 53: // instruction: "remu" "register" "," "register" "," "register"
#line 415 "asm-parse.yy"
{ program_builder.add_remu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1084 "./asm-parse.cc"
    break;

  case 54: // instruction: "remu" "register" "," "register"
#line 421 "asm-parse.yy"
{ program_builder.add_remu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1093 "./asm-parse.cc"
    break;

  case 55: // instruction: "sll" "register" "," "register" "," exp
#line 426 "asm-parse.yy"
{ program_builder.add_sll((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1102 "./asm-parse.cc"
    break;

  case 56: // instruction: "sll" "register" "," exp
#line 431 "asm-parse.yy"
{ program_builder.add_sll((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1110 "./asm-parse.cc"
    break;

  case 57: // instruction: "sll" "register" "," "register" "," "register"
#line 435 "asm-parse.yy"
{ program_builder.add_sllv((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1120 "./asm-parse.cc"
    break;

  case 58: // instruction: "sll" "register" "," "register"
#line 441 "asm-parse.yy"
{ program_builder.add_sllv((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1129 "./asm-parse.cc"
    break;

  case 59: // instruction: "sllv" "register" "," "register" "," "register"
#line 446 "asm-parse.yy"
{ program_builder.add_sllv((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1139 "./asm-parse.cc"
    break;

  case 60: // instruction: "sllv" "register" "," "register"
#line 452 "asm-parse.yy"
{ program_builder.add_sllv((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1148 "./asm-parse.cc"
    break;

  case 61: // instruction: "sra" "register" "," "register" "," exp
#line 457 "asm-parse.yy"
{ program_builder.add_sra((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1157 "./asm-parse.cc"
    break;

  case 62: // instruction: "sra" "register" "," exp
#line 462 "asm-parse.yy"
{ program_builder.add_sra((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1165 "./asm-parse.cc"
    break;

  case 63: // instruction: "sra" "register" "," "register" "," "register"
#line 466 "asm-parse.yy"
{ program_builder.add_srav((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1175 "./asm-parse.cc"
    break;

  case 64: // instruction: "sra" "register" "," "register"
#line 472 "asm-parse.yy"
{ program_builder.add_srav((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1184 "./asm-parse.cc"
    break;

  case 65: // instruction: "srav" "register" "," "register" "," "register"
#line 477 "asm-parse.yy"
{ program_builder.add_srav((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1194 "./asm-parse.cc"
    break;

  case 66: // instruction: "srav" "register" "," "register"
#line 483 "asm-parse.yy"
{ program_builder.add_srav((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1203 "./asm-parse.cc"
    break;

  case 67: // instruction: "srl" "register" "," "register" "," exp
#line 488 "asm-parse.yy"
{ program_builder.add_srl((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1212 "./asm-parse.cc"
    break;

  case 68: // instruction: "srl" "register" "," exp
#line 493 "asm-parse.yy"
{ program_builder.add_srl((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1220 "./asm-parse.cc"
    break;

  case 69: // instruction: "srl" "register" "," "register" "," "register"
#line 497 "asm-parse.yy"
{ program_builder.add_srlv((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1230 "./asm-parse.cc"
    break;

  case 70: // instruction: "srl" "register" "," "register"
#line 503 "asm-parse.yy"
{ program_builder.add_srlv((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1239 "./asm-parse.cc"
    break;

  case 71: // instruction: "srlv" "register" "," "register" "," "register"
#line 508 "asm-parse.yy"
{ program_builder.add_srlv((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1249 "./asm-parse.cc"
    break;

  case 72: // instruction: "srlv" "register" "," "register"
#line 514 "asm-parse.yy"
{ program_builder.add_srlv((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1258 "./asm-parse.cc"
    break;

  case 73: // instruction: "rol" "register" "," "register" "," "register"
#line 519 "asm-parse.yy"
{ program_builder.add_rol((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1268 "./asm-parse.cc"
    break;

  case 74: // instruction: "rol" "register" "," "register"
#line 525 "asm-parse.yy"
{ program_builder.add_rol((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1277 "./asm-parse.cc"
    break;

  case 75: // instruction: "rol" "register" "," "register" "," exp
#line 530 "asm-parse.yy"
{ program_builder.add_rol((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1286 "./asm-parse.cc"
    break;

  case 76: // instruction: "rol" "register" "," exp
#line 535 "asm-parse.yy"
{ program_builder.add_rol((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1294 "./asm-parse.cc"
    break;

  case 77: // instruction: "ror" "register" "," "register" "," "register"
#line 539 "asm-parse.yy"
{ program_builder.add_ror((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1304 "./asm-parse.cc"
    break;

  case 78: // instruction: "ror" "register" "," "register"
#line 545 "asm-parse.yy"
{ program_builder.add_ror((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1313 "./asm-parse.cc"
    break;

  case 79: // instruction: "ror" "register" "," "register" "," exp
#line 550 "asm-parse.yy"
{ program_builder.add_ror((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1322 "./asm-parse.cc"
    break;

  case 80: // instruction: "ror" "register" "," exp
#line 555 "asm-parse.yy"
{ program_builder.add_ror((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1330 "./asm-parse.cc"
    break;

  case 81: // instruction: "and" "register" "," "register" "," "register"
#line 559 "asm-parse.yy"
{ program_builder.add_and((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1340 "./asm-parse.cc"
    break;

  case 82: // instruction: "and" "register" "," "register"
#line 565 "asm-parse.yy"
{ program_builder.add_and((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1349 "./asm-parse.cc"
    break;

  case 83: // instruction: "and" "register" "," "register" "," exp
#line 570 "asm-parse.yy"
{ program_builder.add_andi((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1358 "./asm-parse.cc"
    break;

  case 84: // instruction: "and" "register" "," exp
#line 575 "asm-parse.yy"
{ program_builder.add_andi((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1366 "./asm-parse.cc"
    break;

  case 85: // instruction: "andi" "register" "," "register" "," exp
#line 579 "asm-parse.yy"
{ program_builder.add_andi((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1375 "./asm-parse.cc"
    break;

  case 86: // instruction: "andi" "register" "," exp
#line 584 "asm-parse.yy"
{ program_builder.add_andi((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1383 "./asm-parse.cc"
    break;

  case 87: // instruction: "or" "register" "," "register" "," "register"
#line 588 "asm-parse.yy"
{ program_builder.add_or((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1393 "./asm-parse.cc"
    break;

  case 88: // instruction: "or" "register" "," "register"
#line 594 "asm-parse.yy"
{ program_builder.add_or((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1402 "./asm-parse.cc"
    break;

  case 89: // instruction: "or" "register" "," "register" "," exp
#line 599 "asm-parse.yy"
{ program_builder.add_ori((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1411 "./asm-parse.cc"
    break;

  case 90: // instruction: "or" "register" "," exp
#line 604 "asm-parse.yy"
{ program_builder.add_ori((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1419 "./asm-parse.cc"
    break;

  case 91: // instruction: "ori" "register" "," "register" "," exp
#line 608 "asm-parse.yy"
{ program_builder.add_ori((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1428 "./asm-parse.cc"
    break;

  case 92: // instruction: "ori" "register" "," exp
#line 613 "asm-parse.yy"
{ program_builder.add_ori((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1436 "./asm-parse.cc"
    break;

  case 93: // instruction: "xor" "register" "," "register" "," "register"
#line 617 "asm-parse.yy"
{ program_builder.add_xor((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1446 "./asm-parse.cc"
    break;

  case 94: // instruction: "xor" "register" "," "register"
#line 623 "asm-parse.yy"
{ program_builder.add_xor((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1455 "./asm-parse.cc"
    break;

  case 95: // instruction: "xor" "register" "," "register" "," exp
#line 628 "asm-parse.yy"
{ program_builder.add_xori((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1464 "./asm-parse.cc"
    break;

  case 96: // instruction: "xor" "register" "," exp
#line 633 "asm-parse.yy"
{ program_builder.add_xori((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1472 "./asm-parse.cc"
    break;

  case 97: // instruction: "xori" "register" "," "register" "," exp
#line 637 "asm-parse.yy"
{ program_builder.add_xori((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1481 "./asm-parse.cc"
    break;

  case 98: // instruction: "xori" "register" "," exp
#line 642 "asm-parse.yy"
{ program_builder.add_xori((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1489 "./asm-parse.cc"
    break;

  case 99: // instruction: "nor" "register" "," "register" "," "register"
#line 646 "asm-parse.yy"
{ program_builder.add_nor((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1499 "./asm-parse.cc"
    break;

  case 100: // instruction: "nor" "register" "," "register"
#line 652 "asm-parse.yy"
{ program_builder.add_nor((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1508 "./asm-parse.cc"
    break;

  case 101: // instruction: "nor" "register" "," "register" "," exp
#line 657 "asm-parse.yy"
{ program_builder.add_nor((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1517 "./asm-parse.cc"
    break;

  case 102: // instruction: "nor" "register" "," exp
#line 662 "asm-parse.yy"
{ program_builder.add_nor((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1525 "./asm-parse.cc"
    break;

  case 103: // instruction: "not" "register" "," "register"
#line 666 "asm-parse.yy"
{ program_builder.add_nor((yystack_[2].value.reg), (yystack_[0].value.reg), new Register(Register::general, Cpu::zero));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1534 "./asm-parse.cc"
    break;

  case 104: // instruction: "not" "register"
#line 671 "asm-parse.yy"
{ program_builder.add_nor((yystack_[0].value.reg), (yystack_[0].value.reg), new Register(Register::general, Cpu::zero));
  delete (yystack_[0].value.reg);
}
#line 1542 "./asm-parse.cc"
    break;

  case 105: // instruction: "seq" "register" "," "register" "," "register"
#line 675 "asm-parse.yy"
{ program_builder.add_seq((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1552 "./asm-parse.cc"
    break;

  case 106: // instruction: "seq" "register" "," "register"
#line 681 "asm-parse.yy"
{ program_builder.add_seq((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1561 "./asm-parse.cc"
    break;

  case 107: // instruction: "seq" "register" "," "register" "," exp
#line 686 "asm-parse.yy"
{ program_builder.add_seq((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1570 "./asm-parse.cc"
    break;

  case 108: // instruction: "seq" "register" "," exp
#line 691 "asm-parse.yy"
{ program_builder.add_seq((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1578 "./asm-parse.cc"
    break;

  case 109: // instruction: "sne" "register" "," "register" "," "register"
#line 695 "asm-parse.yy"
{ program_builder.add_sne((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1588 "./asm-parse.cc"
    break;

  case 110: // instruction: "sne" "register" "," "register"
#line 701 "asm-parse.yy"
{ program_builder.add_sne((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1597 "./asm-parse.cc"
    break;

  case 111: // instruction: "sne" "register" "," "register" "," exp
#line 706 "asm-parse.yy"
{ program_builder.add_sne((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1606 "./asm-parse.cc"
    break;

  case 112: // instruction: "sne" "register" "," exp
#line 711 "asm-parse.yy"
{ program_builder.add_sne((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1614 "./asm-parse.cc"
    break;

  case 113: // instruction: "sge" "register" "," "register" "," "register"
#line 715 "asm-parse.yy"
{ program_builder.add_sge((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1624 "./asm-parse.cc"
    break;

  case 114: // instruction: "sge" "register" "," "register"
#line 721 "asm-parse.yy"
{ program_builder.add_sge((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1633 "./asm-parse.cc"
    break;

  case 115: // instruction: "sge" "register" "," "register" "," exp
#line 726 "asm-parse.yy"
{ program_builder.add_sge((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1642 "./asm-parse.cc"
    break;

  case 116: // instruction: "sge" "register" "," exp
#line 731 "asm-parse.yy"
{ program_builder.add_sge((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1650 "./asm-parse.cc"
    break;

  case 117: // instruction: "sgeu" "register" "," "register" "," "register"
#line 735 "asm-parse.yy"
{ program_builder.add_sgeu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1660 "./asm-parse.cc"
    break;

  case 118: // instruction: "sgeu" "register" "," "register"
#line 741 "asm-parse.yy"
{ program_builder.add_sgeu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1669 "./asm-parse.cc"
    break;

  case 119: // instruction: "sgeu" "register" "," "register" "," exp
#line 746 "asm-parse.yy"
{ program_builder.add_sgeu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1678 "./asm-parse.cc"
    break;

  case 120: // instruction: "sgeu" "register" "," exp
#line 751 "asm-parse.yy"
{ program_builder.add_sgeu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1686 "./asm-parse.cc"
    break;

  case 121: // instruction: "sgt" "register" "," "register" "," "register"
#line 755 "asm-parse.yy"
{ program_builder.add_slt((yystack_[4].value.reg), (yystack_[0].value.reg), (yystack_[2].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[0].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1696 "./asm-parse.cc"
    break;

  case 122: // instruction: "sgt" "register" "," "register" "," exp
#line 761 "asm-parse.yy"
{ program_builder.add_sgt((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1705 "./asm-parse.cc"
    break;

  case 123: // instruction: "sgt" "register" "," exp
#line 766 "asm-parse.yy"
{ program_builder.add_sgt((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1713 "./asm-parse.cc"
    break;

  case 124: // instruction: "sgtu" "register" "," "register" "," "register"
#line 770 "asm-parse.yy"
{ program_builder.add_sltu((yystack_[4].value.reg), (yystack_[0].value.reg), (yystack_[2].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[0].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1723 "./asm-parse.cc"
    break;

  case 125: // instruction: "sgtu" "register" "," "register" "," exp
#line 776 "asm-parse.yy"
{ program_builder.add_sgtu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1732 "./asm-parse.cc"
    break;

  case 126: // instruction: "sgtu" "register" "," exp
#line 781 "asm-parse.yy"
{ program_builder.add_sgtu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1740 "./asm-parse.cc"
    break;

  case 127: // instruction: "sle" "register" "," "register" "," "register"
#line 785 "asm-parse.yy"
{ program_builder.add_sle((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1750 "./asm-parse.cc"
    break;

  case 128: // instruction: "sle" "register" "," "register"
#line 791 "asm-parse.yy"
{ program_builder.add_sle((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1759 "./asm-parse.cc"
    break;

  case 129: // instruction: "sle" "register" "," "register" "," exp
#line 796 "asm-parse.yy"
{ program_builder.add_sle((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1768 "./asm-parse.cc"
    break;

  case 130: // instruction: "sle" "register" "," exp
#line 801 "asm-parse.yy"
{ program_builder.add_sle((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1776 "./asm-parse.cc"
    break;

  case 131: // instruction: "sleu" "register" "," "register" "," "register"
#line 805 "asm-parse.yy"
{ program_builder.add_sleu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1786 "./asm-parse.cc"
    break;

  case 132: // instruction: "sleu" "register" "," "register"
#line 811 "asm-parse.yy"
{ program_builder.add_sleu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1795 "./asm-parse.cc"
    break;

  case 133: // instruction: "sleu" "register" "," "register" "," exp
#line 816 "asm-parse.yy"
{ program_builder.add_sleu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1804 "./asm-parse.cc"
    break;

  case 134: // instruction: "sleu" "register" "," exp
#line 821 "asm-parse.yy"
{ program_builder.add_sleu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1812 "./asm-parse.cc"
    break;

  case 135: // instruction: "slt" "register" "," "register" "," "register"
#line 825 "asm-parse.yy"
{ program_builder.add_slt((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1822 "./asm-parse.cc"
    break;

  case 136: // instruction: "slt" "register" "," "register"
#line 831 "asm-parse.yy"
{ program_builder.add_slt((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1831 "./asm-parse.cc"
    break;

  case 137: // instruction: "slt" "register" "," "register" "," exp
#line 836 "asm-parse.yy"
{ program_builder.add_slti((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1840 "./asm-parse.cc"
    break;

  case 138: // instruction: "slt" "register" "," exp
#line 841 "asm-parse.yy"
{ program_builder.add_slti((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1848 "./asm-parse.cc"
    break;

  case 139: // instruction: "sltu" "register" "," "register" "," "register"
#line 845 "asm-parse.yy"
{ program_builder.add_sltu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1858 "./asm-parse.cc"
    break;

  case 140: // instruction: "sltu" "register" "," "register"
#line 851 "asm-parse.yy"
{ program_builder.add_sltu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 1867 "./asm-parse.cc"
    break;

  case 141: // instruction: "sltu" "register" "," "register" "," exp
#line 856 "asm-parse.yy"
{ program_builder.add_sltiu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1876 "./asm-parse.cc"
    break;

  case 142: // instruction: "sltu" "register" "," exp
#line 861 "asm-parse.yy"
{ program_builder.add_sltiu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1884 "./asm-parse.cc"
    break;

  case 143: // instruction: "slti" "register" "," "register" "," exp
#line 865 "asm-parse.yy"
{ program_builder.add_slti((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1893 "./asm-parse.cc"
    break;

  case 144: // instruction: "slti" "register" "," exp
#line 870 "asm-parse.yy"
{ program_builder.add_slti((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1901 "./asm-parse.cc"
    break;

  case 145: // instruction: "sltiu" "register" "," "register" "," exp
#line 874 "asm-parse.yy"
{ program_builder.add_sltiu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1910 "./asm-parse.cc"
    break;

  case 146: // instruction: "sltiu" "register" "," exp
#line 879 "asm-parse.yy"
{ program_builder.add_sltiu((yystack_[2].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1918 "./asm-parse.cc"
    break;

  case 147: // instruction: "beq" "register" "," "register" "," exp
#line 883 "asm-parse.yy"
{ program_builder.add_beq((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1927 "./asm-parse.cc"
    break;

  case 148: // instruction: "beq" "register" "," exp "," exp
#line 888 "asm-parse.yy"
{ program_builder.add_beq((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
#line 1935 "./asm-parse.cc"
    break;

  case 149: // instruction: "beqz" "register" "," exp
#line 892 "asm-parse.yy"
{ program_builder.add_beq((yystack_[2].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1943 "./asm-parse.cc"
    break;

  case 150: // instruction: "bne" "register" "," "register" "," exp
#line 896 "asm-parse.yy"
{ program_builder.add_bne((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1952 "./asm-parse.cc"
    break;

  case 151: // instruction: "bne" "register" "," exp "," exp
#line 901 "asm-parse.yy"
{ program_builder.add_bne((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
#line 1960 "./asm-parse.cc"
    break;

  case 152: // instruction: "bnez" "register" "," exp
#line 905 "asm-parse.yy"
{ program_builder.add_bne((yystack_[2].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 1968 "./asm-parse.cc"
    break;

  case 153: // instruction: "bge" "register" "," "register" "," exp
#line 909 "asm-parse.yy"
{ program_builder.add_bge((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1977 "./asm-parse.cc"
    break;

  case 154: // instruction: "bge" "register" "," exp "," exp
#line 914 "asm-parse.yy"
{ program_builder.add_bge((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
#line 1985 "./asm-parse.cc"
    break;

  case 155: // instruction: "bgeu" "register" "," "register" "," exp
#line 918 "asm-parse.yy"
{ program_builder.add_bgeu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 1994 "./asm-parse.cc"
    break;

  case 156: // instruction: "bgeu" "register" "," exp "," exp
#line 923 "asm-parse.yy"
{ program_builder.add_bgeu((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
#line 2002 "./asm-parse.cc"
    break;

  case 157: // instruction: "bgez" "register" "," exp
#line 927 "asm-parse.yy"
{ program_builder.add_bgez((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 2010 "./asm-parse.cc"
    break;

  case 158: // instruction: "bgezal" "register" "," exp
#line 931 "asm-parse.yy"
{ program_builder.add_bgezal((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 2018 "./asm-parse.cc"
    break;

  case 159: // instruction: "bgt" "register" "," "register" "," exp
#line 935 "asm-parse.yy"
{ program_builder.add_bgt((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 2027 "./asm-parse.cc"
    break;

  case 160: // instruction: "bgt" "register" "," exp "," exp
#line 940 "asm-parse.yy"
{ program_builder.add_bgt((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
#line 2035 "./asm-parse.cc"
    break;

  case 161: // instruction: "bgtu" "register" "," "register" "," exp
#line 944 "asm-parse.yy"
{ program_builder.add_bgtu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 2044 "./asm-parse.cc"
    break;

  case 162: // instruction: "bgtu" "register" "," exp "," exp
#line 949 "asm-parse.yy"
{ program_builder.add_bgtu((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
#line 2052 "./asm-parse.cc"
    break;

  case 163: // instruction: "bgtz" "register" "," exp
#line 953 "asm-parse.yy"
{ program_builder.add_bgtz((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 2060 "./asm-parse.cc"
    break;

  case 164: // instruction: "ble" "register" "," "register" "," exp
#line 957 "asm-parse.yy"
{ program_builder.add_ble((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 2069 "./asm-parse.cc"
    break;

  case 165: // instruction: "ble" "register" "," exp "," exp
#line 962 "asm-parse.yy"
{ program_builder.add_ble((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
#line 2077 "./asm-parse.cc"
    break;

  case 166: // instruction: "bleu" "register" "," "register" "," exp
#line 966 "asm-parse.yy"
{ program_builder.add_bleu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 2086 "./asm-parse.cc"
    break;

  case 167: // instruction: "bleu" "register" "," exp "," exp
#line 971 "asm-parse.yy"
{ program_builder.add_bleu((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
#line 2094 "./asm-parse.cc"
    break;

  case 168: // instruction: "blez" "register" "," exp
#line 975 "asm-parse.yy"
{ program_builder.add_blez((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 2102 "./asm-parse.cc"
    break;

  case 169: // instruction: "blt" "register" "," "register" "," exp
#line 979 "asm-parse.yy"
{ program_builder.add_blt((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 2111 "./asm-parse.cc"
    break;

  case 170: // instruction: "blt" "register" "," exp "," exp
#line 984 "asm-parse.yy"
{ program_builder.add_blt((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
#line 2119 "./asm-parse.cc"
    break;

  case 171: // instruction: "bltu" "register" "," "register" "," exp
#line 988 "asm-parse.yy"
{ program_builder.add_bltu((yystack_[4].value.reg), (yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
  delete (yystack_[2].value.reg);
}
#line 2128 "./asm-parse.cc"
    break;

  case 172: // instruction: "bltu" "register" "," exp "," exp
#line 993 "asm-parse.yy"
{ program_builder.add_bltu((yystack_[4].value.reg), (yystack_[2].value.exp), (yystack_[0].value.exp));
  delete (yystack_[4].value.reg);
}
#line 2136 "./asm-parse.cc"
    break;

  case 173: // instruction: "bltz" "register" "," exp
#line 997 "asm-parse.yy"
{ program_builder.add_bltz((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 2144 "./asm-parse.cc"
    break;

  case 174: // instruction: "bltzal" "register" "," exp
#line 1001 "asm-parse.yy"
{ program_builder.add_bltzal((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 2152 "./asm-parse.cc"
    break;

  case 175: // instruction: "j" exp
#line 1005 "asm-parse.yy"
{ program_builder.add_j((yystack_[0].value.exp));
}
#line 2159 "./asm-parse.cc"
    break;

  case 176: // instruction: "jal" exp
#line 1008 "asm-parse.yy"
{ program_builder.add_jal((yystack_[0].value.exp));
}
#line 2166 "./asm-parse.cc"
    break;

  case 177: // instruction: "jr" "register"
#line 1011 "asm-parse.yy"
{ program_builder.add_jr((yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
#line 2174 "./asm-parse.cc"
    break;

  case 178: // instruction: "jalr" "register"
#line 1015 "asm-parse.yy"
{ program_builder.add_jalr((yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
#line 2182 "./asm-parse.cc"
    break;

  case 179: // instruction: "lb" "register" "," exp "(" "register" ")"
#line 1019 "asm-parse.yy"
{ program_builder.add_lb((yystack_[5].value.reg), (yystack_[3].value.exp), (yystack_[1].value.reg));
  delete (yystack_[5].value.reg);
  delete (yystack_[1].value.reg);
}
#line 2191 "./asm-parse.cc"
    break;

  case 180: // instruction: "lb" "register" "," "(" "register" ")"
#line 1024 "asm-parse.yy"
{ program_builder.add_lb((yystack_[4].value.reg), new IntExp(0), (yystack_[1].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[1].value.reg);
}
#line 2200 "./asm-parse.cc"
    break;

  case 181: // instruction: "lbu" "register" "," exp "(" "register" ")"
#line 1029 "asm-parse.yy"
{ program_builder.add_lbu((yystack_[5].value.reg), (yystack_[3].value.exp), (yystack_[1].value.reg));
  delete (yystack_[5].value.reg);
  delete (yystack_[1].value.reg);
}
#line 2209 "./asm-parse.cc"
    break;

  case 182: // instruction: "lbu" "register" "," "(" "register" ")"
#line 1034 "asm-parse.yy"
{ program_builder.add_lbu((yystack_[4].value.reg), new IntExp(0), (yystack_[1].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[1].value.reg);
}
#line 2218 "./asm-parse.cc"
    break;

  case 183: // instruction: "lw" "register" "," exp "(" "register" ")"
#line 1039 "asm-parse.yy"
{ program_builder.add_lw((yystack_[5].value.reg), (yystack_[3].value.exp), (yystack_[1].value.reg));
  delete (yystack_[5].value.reg);
  delete (yystack_[1].value.reg);
}
#line 2227 "./asm-parse.cc"
    break;

  case 184: // instruction: "lw" "register" "," "(" "register" ")"
#line 1044 "asm-parse.yy"
{ program_builder.add_lw((yystack_[4].value.reg), new IntExp(0), (yystack_[1].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[1].value.reg);
}
#line 2236 "./asm-parse.cc"
    break;

  case 185: // instruction: "lui" "register" "," exp
#line 1049 "asm-parse.yy"
{ program_builder.add_lui((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 2244 "./asm-parse.cc"
    break;

  case 186: // instruction: "li" "register" "," exp
#line 1053 "asm-parse.yy"
{ program_builder.add_ori((yystack_[2].value.reg), new Register(Register::general, Cpu::zero), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 2252 "./asm-parse.cc"
    break;

  case 187: // instruction: "la" "register" "," exp "(" "register" ")"
#line 1057 "asm-parse.yy"
{ program_builder.add_la((yystack_[5].value.reg), (yystack_[3].value.exp), (yystack_[1].value.reg));
  delete (yystack_[5].value.reg);
  delete (yystack_[1].value.reg);
}
#line 2261 "./asm-parse.cc"
    break;

  case 188: // instruction: "la" "register" "," "(" "register" ")"
#line 1062 "asm-parse.yy"
{ program_builder.add_la((yystack_[4].value.reg), new IntExp(0), (yystack_[1].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[1].value.reg);
}
#line 2270 "./asm-parse.cc"
    break;

  case 189: // instruction: "la" "register" "," exp
#line 1067 "asm-parse.yy"
{ program_builder.add_la((yystack_[2].value.reg), (yystack_[0].value.exp));
  delete (yystack_[2].value.reg);
}
#line 2278 "./asm-parse.cc"
    break;

  case 190: // instruction: "sb" "register" "," exp "(" "register" ")"
#line 1071 "asm-parse.yy"
{ program_builder.add_sb((yystack_[5].value.reg), (yystack_[3].value.exp), (yystack_[1].value.reg));
  delete (yystack_[5].value.reg);
  delete (yystack_[1].value.reg);
}
#line 2287 "./asm-parse.cc"
    break;

  case 191: // instruction: "sb" "register" "," "(" "register" ")"
#line 1076 "asm-parse.yy"
{ program_builder.add_sb((yystack_[4].value.reg), new IntExp(0), (yystack_[1].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[1].value.reg);
}
#line 2296 "./asm-parse.cc"
    break;

  case 192: // instruction: "sw" "register" "," exp "(" "register" ")"
#line 1081 "asm-parse.yy"
{ program_builder.add_sw((yystack_[5].value.reg), (yystack_[3].value.exp), (yystack_[1].value.reg));
  delete (yystack_[5].value.reg);
  delete (yystack_[1].value.reg);
}
#line 2305 "./asm-parse.cc"
    break;

  case 193: // instruction: "sw" "register" "," "(" "register" ")"
#line 1086 "asm-parse.yy"
{ program_builder.add_sw((yystack_[4].value.reg), new IntExp(0), (yystack_[1].value.reg));
  delete (yystack_[4].value.reg);
  delete (yystack_[1].value.reg);
}
#line 2314 "./asm-parse.cc"
    break;

  case 194: // instruction: "move" "register" "," "register"
#line 1091 "asm-parse.yy"
{ program_builder.add_addu((yystack_[2].value.reg), (yystack_[0].value.reg), new Register(Register::general, Cpu::zero));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 2323 "./asm-parse.cc"
    break;

  case 195: // instruction: "mfhi" "register"
#line 1096 "asm-parse.yy"
{ program_builder.add_mfhi((yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
#line 2331 "./asm-parse.cc"
    break;

  case 196: // instruction: "mflo" "register"
#line 1100 "asm-parse.yy"
{ program_builder.add_mflo((yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
#line 2339 "./asm-parse.cc"
    break;

  case 197: // instruction: "mthi" "register"
#line 1104 "asm-parse.yy"
{ program_builder.add_mthi((yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
#line 2347 "./asm-parse.cc"
    break;

  case 198: // instruction: "mtlo" "register"
#line 1108 "asm-parse.yy"
{ program_builder.add_mtlo((yystack_[0].value.reg));
  delete (yystack_[0].value.reg);
}
#line 2355 "./asm-parse.cc"
    break;

  case 199: // instruction: "mfc0" "register" "," "register"
#line 1112 "asm-parse.yy"
{ program_builder.add_mfc0((yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 2364 "./asm-parse.cc"
    break;

  case 200: // instruction: "mtc0" "register" "," "register"
#line 1117 "asm-parse.yy"
{ program_builder.add_mtc0((yystack_[2].value.reg), (yystack_[0].value.reg));
  delete (yystack_[2].value.reg);
  delete (yystack_[0].value.reg);
}
#line 2373 "./asm-parse.cc"
    break;

  case 201: // instruction: "syscall"
#line 1122 "asm-parse.yy"
{ program_builder.add_syscall();
}
#line 2380 "./asm-parse.cc"
    break;

  case 202: // instruction: "nop"
#line 1125 "asm-parse.yy"
{ program_builder.add_sll(new Register(Register::general, Cpu::zero), new Register(Register::general, Cpu::zero), new IntExp(0));
}
#line 2387 "./asm-parse.cc"
    break;

  case 203: // exp: exp EXP_ADD exp
#line 1129 "asm-parse.yy"
                   { (yylhs.value.exp) = new OpExp((yystack_[2].value.exp), OpExp::add, (yystack_[0].value.exp)); }
#line 2393 "./asm-parse.cc"
    break;

  case 204: // exp: exp EXP_SUB exp
#line 1130 "asm-parse.yy"
                   { (yylhs.value.exp) = new OpExp((yystack_[2].value.exp), OpExp::sub, (yystack_[0].value.exp)); }
#line 2399 "./asm-parse.cc"
    break;

  case 205: // exp: exp EXP_MUL exp
#line 1131 "asm-parse.yy"
                   { (yylhs.value.exp) = new OpExp((yystack_[2].value.exp), OpExp::mul, (yystack_[0].value.exp)); }
#line 2405 "./asm-parse.cc"
    break;

  case 206: // exp: exp EXP_DIV exp
#line 1132 "asm-parse.yy"
                   { (yylhs.value.exp) = new OpExp((yystack_[2].value.exp), OpExp::div, (yystack_[0].value.exp)); }
#line 2411 "./asm-parse.cc"
    break;

  case 207: // exp: EXP_SUB exp
#line 1134 "asm-parse.yy"
        { (yylhs.value.exp) = new OpExp(new IntExp(0), OpExp::sub, (yystack_[0].value.exp)); }
#line 2417 "./asm-parse.cc"
    break;

  case 208: // exp: "(" exp ")"
#line 1135 "asm-parse.yy"
                    { (yylhs.value.exp) = (yystack_[1].value.exp); }
#line 2423 "./asm-parse.cc"
    break;

  case 209: // exp: "integer"
#line 1136 "asm-parse.yy"
          { (yylhs.value.exp) = new IntExp((yystack_[0].value.i)); }
#line 2429 "./asm-parse.cc"
    break;

  case 210: // exp: "label"
#line 1137 "asm-parse.yy"
        { (yylhs.value.exp) = new LabelExp(*(yystack_[0].value.id)); }
#line 2435 "./asm-parse.cc"
    break;


#line 2439 "./asm-parse.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // parser::context.
  parser::context::context (const parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const signed char parser::yypact_ninf_ = -69;

  const signed char parser::yytable_ninf_ = -1;

  const short
  parser::yypact_[] =
  {
     -69,     6,   -69,   -69,   -69,   176,    -2,   -69,    -3,     7,
      18,    20,    24,    30,    36,    42,    48,    54,    60,    66,
      72,    77,    78,    82,    92,    98,   104,   109,   110,   111,
     118,   120,   124,   130,   142,   174,   188,   275,   277,   281,
     287,   293,   299,   304,   305,   306,   308,   309,   319,   320,
     322,   324,   326,   369,   371,   375,   381,   387,   393,   399,
     405,   411,   417,   423,   429,   435,   441,   447,   127,   127,
     453,   459,   465,   471,   477,   483,   489,   495,   501,   507,
     513,   519,   525,   531,   537,   543,   549,   -69,   -69,   -69,
     -69,    10,   557,   563,     8,   568,   574,   -69,   657,   663,
     669,   675,   681,   687,   689,   691,   698,   705,   712,   719,
     726,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   -69,   -69,
     127,   127,   781,   781,   -69,   -69,   833,   834,   835,   836,
     837,   838,   839,   840,   841,   -69,   -69,   -69,   -69,   842,
     843,   -69,   -69,   -69,   -69,   -69,   -69,   -69,     0,    21,
      27,    33,   579,   585,   591,   597,   603,   609,   615,   621,
     627,   633,    39,   639,    45,   645,    51,   651,    57,    63,
      69,    75,    83,    89,    95,   101,   107,   702,   121,   278,
     284,   290,   296,   302,   372,   378,   384,   390,   396,   402,
     408,   127,   414,   127,   420,   426,   127,   127,   432,   438,
     127,   444,   450,   127,   456,   462,   127,   127,   185,   -69,
     127,   127,   127,   127,   660,   666,   672,   127,   127,   678,
     684,   690,   709,   716,   723,   844,   781,   845,   781,   846,
     781,   847,   781,   848,   849,   -69,   -69,   -69,   850,   851,
     852,   853,   854,   855,   781,   856,   857,   781,   858,   859,
     781,   860,   861,   781,   862,   781,   863,   781,   864,   781,
     865,   781,   866,   781,   867,   781,   868,   781,   869,   781,
     -69,   870,   781,   871,   781,   872,   781,   873,   781,   874,
     781,   875,   781,   876,   781,   877,   781,   878,   781,   879,
     781,   880,   781,   881,   781,   882,   732,   781,   883,   737,
     781,   884,   742,   885,   747,   781,   781,   886,   752,   887,
     757,   781,   888,   762,   889,   767,   781,   890,   772,   891,
     777,   781,   781,   -69,    -4,    -4,   -69,   -69,   468,   692,
     474,   699,   480,   706,   781,   781,   486,   713,   492,   720,
     498,   727,   -69,   -69,   -69,   504,   510,   127,   127,   516,
     522,   528,   534,   540,   730,   895,   546,   896,   552,   897,
     558,   898,   564,   570,   576,   127,   582,   127,   588,   127,
     594,   600,   606,   612,   618,   624,   630,   636,   642,   648,
     654,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   655,   899,   661,   900,   667,   901,   673,
     902,   679,   903,   685,   904,   -69,   781,   -69,   781,   781,
     781,   -69,   781,   -69,   781,   -69,   781,   -69,   781,   -69,
     781,   -69,   -69,   -69,   781,   -69,   -69,   781,   -69,   -69,
     781,   -69,   -69,   781,   -69,   781,   -69,   781,   781,   -69,
     781,   781,   -69,   781,   781,   -69,   781,   -69,   781,   -69,
     781,   -69,   781,   -69,   781,   -69,   781,   -69,   781,   -69,
     781,   -69,   781,   -69,   781,   -69,   781,   781,   781,   781,
     781,   781,   781,   781,   781,   781,   781,   781,   781,   781,
     781,   781,   781,   781,   781,   781,   781,   781,   781,   -69,
     905,   -69,   906,   -69,   907,   -69,   908,   -69,   909,   -69,
     910,   -69,   -69,   -69,   -69,   -69,   -69
  };

  const unsigned char
  parser::yydefact_[] =
  {
       2,     0,     1,    15,     5,     3,     4,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   201,   202,    16,
       7,     0,     0,     0,     0,     0,     0,     6,     0,     0,
       0,     0,     0,     0,    37,    39,    41,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   210,   209,
       0,     0,   175,   176,   177,   178,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   195,   196,   197,   198,     0,
       0,     8,     9,    10,    12,    11,    13,    14,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   207,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    19,    21,    23,    25,     0,
      27,     0,    29,    31,    34,    36,    38,    40,    43,    45,
      48,    52,    54,    58,    56,    60,    64,    62,    66,    70,
      68,    72,    74,    76,    78,    80,    82,    84,     0,    86,
      88,    90,     0,    92,    94,    96,     0,    98,   100,   102,
     103,   106,   108,   110,   112,   114,   116,   118,   120,     0,
     123,     0,   126,   128,   130,   132,   134,   136,   138,   140,
     142,     0,   144,     0,   146,     0,     0,   149,     0,     0,
     152,     0,     0,     0,     0,   157,   158,     0,     0,     0,
       0,   163,     0,     0,     0,     0,   168,     0,     0,     0,
       0,   173,   174,   208,   203,   204,   205,   206,     0,     0,
       0,     0,     0,     0,   185,   186,     0,   189,     0,     0,
       0,     0,   194,   199,   200,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,    20,    22,    24,    26,
      28,    30,    32,    33,    35,    42,    44,    46,    47,    49,
      50,    51,    53,    57,    55,    59,    63,    61,    65,    69,
      67,    71,    73,    75,    77,    79,    81,    83,    85,    87,
      89,    91,    93,    95,    97,    99,   101,   105,   107,   109,
     111,   113,   115,   117,   119,   121,   122,   124,   125,   127,
     129,   131,   133,   135,   137,   139,   141,   143,   145,   147,
     148,   150,   151,   153,   154,   155,   156,   159,   160,   161,
     162,   164,   165,   166,   167,   169,   170,   171,   172,   180,
       0,   182,     0,   184,     0,   188,     0,   191,     0,   193,
       0,   179,   181,   183,   187,   190,   192
  };

  const signed char
  parser::yypgoto_[] =
  {
     -69,   -69,   -69,   -69,   -69,   -69,   -68
  };

  const unsigned char
  parser::yydefgoto_[] =
  {
       0,     1,     6,    97,     5,    89,   248
  };

  const short
  parser::yytable_[] =
  {
     162,   163,    90,   158,    98,   159,     2,   265,   160,   252,
     253,   184,   161,   185,    99,   181,    91,    92,    93,    94,
      95,    96,     3,     4,   158,   100,   159,   101,   267,   160,
     158,   102,   159,   161,   269,   160,   158,   103,   159,   161,
     271,   160,   158,   104,   159,   161,   283,   160,   158,   105,
     159,   161,   286,   160,   158,   106,   159,   161,   289,   160,
     158,   107,   159,   161,   292,   160,   158,   108,   159,   161,
     294,   160,   158,   109,   159,   161,   296,   160,   158,   110,
     159,   161,   298,   160,   111,   112,   158,   161,   159,   113,
     300,   160,   158,   249,   159,   161,   302,   160,   158,   114,
     159,   161,   304,   160,   158,   115,   159,   161,   306,   160,
     158,   116,   159,   161,   308,   160,   117,   118,   119,   161,
     266,   268,   270,   272,   158,   120,   159,   121,   311,   160,
     158,   122,   159,   161,   284,   160,   287,   123,   290,   161,
     293,   295,   297,   299,   301,   303,   305,   307,   309,   124,
     312,   314,   316,   318,   320,   322,   324,   326,   328,   330,
     332,   334,   336,   337,   339,   340,   342,   344,   345,   346,
     348,   350,   351,   353,   355,   356,   358,   360,   361,   362,
       7,   125,   364,   365,   366,   367,   369,   371,   373,   374,
     375,   377,   379,   381,   363,   126,   250,   251,   252,   253,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,   158,   127,   159,   128,   313,   160,   158,   129,   159,
     161,   315,   160,   158,   130,   159,   161,   317,   160,   158,
     131,   159,   161,   319,   160,   158,   132,   159,   161,   321,
     160,   133,   134,   135,   161,   136,   137,   456,   458,   459,
     460,   462,   464,   466,   468,   470,   138,   139,   474,   140,
     477,   141,   480,   142,   483,   485,   487,   488,   490,   491,
     493,   494,   496,   498,   500,   502,   504,   506,   508,   510,
     512,   514,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   158,   143,   159,   144,   323,
     160,   158,   145,   159,   161,   325,   160,   158,   146,   159,
     161,   327,   160,   158,   147,   159,   161,   329,   160,   158,
     148,   159,   161,   331,   160,   158,   149,   159,   161,   333,
     160,   158,   150,   159,   161,   335,   160,   158,   151,   159,
     161,   338,   160,   158,   152,   159,   161,   341,   160,   158,
     153,   159,   161,   343,   160,   158,   154,   159,   161,   347,
     160,   158,   155,   159,   161,   349,   160,   158,   156,   159,
     161,   352,   160,   158,   157,   159,   161,   354,   160,   158,
     164,   159,   161,   357,   160,   158,   165,   159,   161,   359,
     160,   158,   166,   159,   161,   443,   160,   158,   167,   159,
     161,   445,   160,   158,   168,   159,   161,   447,   160,   158,
     169,   159,   161,   449,   160,   158,   170,   159,   161,   451,
     160,   158,   171,   159,   161,   453,   160,   158,   172,   159,
     161,   455,   160,   158,   173,   159,   161,   457,   160,   158,
     174,   159,   161,   461,   160,   158,   175,   159,   161,   463,
     160,   158,   176,   159,   161,   465,   160,   158,   177,   159,
     161,   467,   160,   158,   178,   159,   161,   469,   160,   158,
     179,   159,   161,   473,   160,   158,   180,   159,   161,   476,
     160,   158,   182,   159,   161,   479,   160,   158,   183,   159,
     161,   482,   160,   158,   186,   159,   161,   484,   160,   158,
     187,   159,   161,   486,   160,   158,   273,   159,   161,   489,
     160,   158,   274,   159,   161,   492,   160,   158,   275,   159,
     161,   495,   160,   158,   276,   159,   161,   497,   160,   158,
     277,   159,   161,   499,   160,   158,   278,   159,   161,   501,
     160,   158,   279,   159,   161,   503,   160,   158,   280,   159,
     161,   505,   160,   158,   281,   159,   161,   507,   160,   158,
     282,   159,   161,   509,   160,   158,   285,   159,   161,   511,
     160,   158,   288,   159,   161,   513,   160,   158,   291,   159,
     161,   515,   160,   158,   539,   159,   161,   188,   368,   158,
     541,   159,   161,   189,   370,   158,   543,   159,   161,   190,
     372,   158,   545,   159,   161,   191,   376,   158,   547,   159,
     161,   192,   378,   158,   549,   159,   161,   193,   380,   194,
     444,   195,   161,   250,   251,   252,   253,   446,   196,   310,
     250,   251,   252,   253,   448,   197,   382,   250,   251,   252,
     253,   450,   198,   383,   250,   251,   252,   253,   452,   199,
     384,   250,   251,   252,   253,   454,   200,   471,   250,   251,
     252,   253,   424,   250,   251,   252,   253,   426,   250,   251,
     252,   253,   428,   250,   251,   252,   253,   430,   250,   251,
     252,   253,   432,   250,   251,   252,   253,   434,   250,   251,
     252,   253,   436,   250,   251,   252,   253,   438,   250,   251,
     252,   253,   440,   250,   251,   252,   253,   442,   250,   251,
     252,   253,   250,   251,   252,   253,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   425,   427,   429,   431,   433,   435,   437,
     439,   441,   472,   475,   478,   481,   540,   542,   544,   546,
     548,   550,     0,     0,   551,   552,   553,   554,   555,   556
  };

  const short
  parser::yycheck_[] =
  {
      68,    69,     4,     3,     7,     5,     0,     7,     8,    13,
      14,     3,    12,     5,     7,     5,    18,    19,    20,    21,
      22,    23,    16,    17,     3,     7,     5,     7,     7,     8,
       3,     7,     5,    12,     7,     8,     3,     7,     5,    12,
       7,     8,     3,     7,     5,    12,     7,     8,     3,     7,
       5,    12,     7,     8,     3,     7,     5,    12,     7,     8,
       3,     7,     5,    12,     7,     8,     3,     7,     5,    12,
       7,     8,     3,     7,     5,    12,     7,     8,     3,     7,
       5,    12,     7,     8,     7,     7,     3,    12,     5,     7,
       7,     8,     3,   161,     5,    12,     7,     8,     3,     7,
       5,    12,     7,     8,     3,     7,     5,    12,     7,     8,
       3,     7,     5,    12,     7,     8,     7,     7,     7,    12,
     188,   189,   190,   191,     3,     7,     5,     7,     7,     8,
       3,     7,     5,    12,   202,     8,   204,     7,   206,    12,
     208,   209,   210,   211,   212,   213,   214,   215,   216,     7,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
       4,     7,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     9,     7,    11,    12,    13,    14,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     3,     7,     5,     7,     7,     8,     3,     7,     5,
      12,     7,     8,     3,     7,     5,    12,     7,     8,     3,
       7,     5,    12,     7,     8,     3,     7,     5,    12,     7,
       8,     7,     7,     7,    12,     7,     7,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     7,     7,   396,     7,
     398,     7,   400,     7,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,     3,     7,     5,     7,     7,
       8,     3,     7,     5,    12,     7,     8,     3,     7,     5,
      12,     7,     8,     3,     7,     5,    12,     7,     8,     3,
       7,     5,    12,     7,     8,     3,     7,     5,    12,     7,
       8,     3,     7,     5,    12,     7,     8,     3,     7,     5,
      12,     7,     8,     3,     7,     5,    12,     7,     8,     3,
       7,     5,    12,     7,     8,     3,     7,     5,    12,     7,
       8,     3,     7,     5,    12,     7,     8,     3,     7,     5,
      12,     7,     8,     3,     7,     5,    12,     7,     8,     3,
       7,     5,    12,     7,     8,     3,     7,     5,    12,     7,
       8,     3,     7,     5,    12,     7,     8,     3,     7,     5,
      12,     7,     8,     3,     7,     5,    12,     7,     8,     3,
       7,     5,    12,     7,     8,     3,     7,     5,    12,     7,
       8,     3,     7,     5,    12,     7,     8,     3,     7,     5,
      12,     7,     8,     3,     7,     5,    12,     7,     8,     3,
       7,     5,    12,     7,     8,     3,     7,     5,    12,     7,
       8,     3,     7,     5,    12,     7,     8,     3,     7,     5,
      12,     7,     8,     3,     7,     5,    12,     7,     8,     3,
       7,     5,    12,     7,     8,     3,     7,     5,    12,     7,
       8,     3,     5,     5,    12,     7,     8,     3,     5,     5,
      12,     7,     8,     3,     6,     5,    12,     7,     8,     3,
       6,     5,    12,     7,     8,     3,     7,     5,    12,     7,
       8,     3,     7,     5,    12,     7,     8,     3,     7,     5,
      12,     7,     8,     3,     7,     5,    12,     7,     8,     3,
       7,     5,    12,     7,     8,     3,     7,     5,    12,     7,
       8,     3,     7,     5,    12,     7,     8,     3,     7,     5,
      12,     7,     8,     3,     7,     5,    12,     7,     8,     3,
       7,     5,    12,     7,     8,     3,     7,     5,    12,     7,
       8,     3,     7,     5,    12,     7,     8,     3,     7,     5,
      12,     7,     8,     3,     9,     5,    12,    10,     8,     3,
       9,     5,    12,    10,     8,     3,     9,     5,    12,    10,
       8,     3,     9,     5,    12,    10,     8,     3,     9,     5,
      12,    10,     8,     3,     9,     5,    12,    10,     8,    10,
       8,    10,    12,    11,    12,    13,    14,     8,    10,     7,
      11,    12,    13,    14,     8,    10,     7,    11,    12,    13,
      14,     8,    10,     7,    11,    12,    13,    14,     8,    10,
       7,    11,    12,    13,    14,     8,    10,     7,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    10,    11,    12,    13,    14,    10,    11,    12,
      13,    14,    11,    12,    13,    14,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,    -1,    -1,     9,     9,     9,     9,     9,     9
  };

  const signed char
  parser::yystos_[] =
  {
       0,   106,     0,    16,    17,   109,   107,     4,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   110,
       4,    18,    19,    20,    21,    22,    23,   108,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     3,     5,
       8,    12,   111,   111,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
       7,     5,     5,     5,     3,     5,     6,     6,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,   111,   111,
      11,    12,    13,    14,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,     7,   111,     7,   111,     7,
     111,     7,   111,     7,     7,     7,     7,     7,     7,     7,
       7,     7,     7,     7,   111,     7,     7,   111,     7,     7,
     111,     7,     7,   111,     7,   111,     7,   111,     7,   111,
       7,   111,     7,   111,     7,   111,     7,   111,     7,   111,
       7,     7,   111,     7,   111,     7,   111,     7,   111,     7,
     111,     7,   111,     7,   111,     7,   111,     7,   111,     7,
     111,     7,   111,     7,   111,     7,   111,   111,     7,   111,
     111,     7,   111,     7,   111,   111,   111,     7,   111,     7,
     111,   111,     7,   111,     7,   111,   111,     7,   111,     7,
     111,   111,   111,     9,   111,   111,   111,   111,     8,   111,
       8,   111,     8,   111,   111,   111,     8,   111,     8,   111,
       8,   111,     7,     7,     7,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,    10,    10,    10,    10,    10,    10,    10,
      10,    10,    10,     7,     8,     7,     8,     7,     8,     7,
       8,     7,     8,     7,     8,     7,   111,     7,   111,   111,
     111,     7,   111,     7,   111,     7,   111,     7,   111,     7,
     111,     7,     7,     7,   111,     7,     7,   111,     7,     7,
     111,     7,     7,   111,     7,   111,     7,   111,   111,     7,
     111,   111,     7,   111,   111,     7,   111,     7,   111,     7,
     111,     7,   111,     7,   111,     7,   111,     7,   111,     7,
     111,     7,   111,     7,   111,     7,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     111,   111,   111,   111,   111,   111,   111,   111,   111,     9,
       7,     9,     7,     9,     7,     9,     7,     9,     7,     9,
       7,     9,     9,     9,     9,     9,     9
  };

  const signed char
  parser::yyr1_[] =
  {
       0,   105,   106,   106,   106,   107,   107,   108,   108,   108,
     108,   108,   108,   108,   108,   109,   109,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   111,   111,   111,   111,   111,   111,   111,
     111
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     0,     3,     3,     0,     2,     1,     2,     2,
       2,     2,     2,     2,     2,     0,     2,     1,     6,     4,
       6,     4,     6,     4,     6,     4,     6,     4,     6,     4,
       6,     4,     6,     6,     4,     6,     4,     2,     4,     2,
       4,     2,     6,     4,     6,     4,     6,     6,     4,     6,
       6,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     4,     2,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     6,     4,     6,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     4,     6,     4,     6,     6,     4,
       6,     6,     4,     6,     6,     6,     6,     4,     4,     6,
       6,     6,     6,     4,     6,     6,     6,     6,     4,     6,
       6,     6,     6,     4,     4,     2,     2,     2,     2,     7,
       6,     7,     6,     7,     6,     4,     4,     7,     6,     4,
       7,     6,     7,     6,     4,     2,     2,     2,     2,     4,
       4,     1,     1,     3,     3,     3,     3,     2,     3,     1,
       1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\"label\"",
  "\"label definition\"", "\"integer\"", "\"string\"", "\"register\"",
  "\"(\"", "\")\"", "\",\"", "EXP_ADD", "EXP_SUB", "EXP_MUL", "EXP_DIV",
  "EXP_UMINUS", "\".text\"", "\".data\"", "\".space\"", "\".byte\"",
  "\".half\"", "\".word\"", "\".ascii\"", "\".asciiz\"", "\"add\"",
  "\"addu\"", "\"addi\"", "\"addiu\"", "\"sub\"", "\"subu\"", "\"neg\"",
  "\"negu\"", "\"abs\"", "\"mul\"", "\"div\"", "\"divu\"", "\"rem\"",
  "\"remu\"", "\"sll\"", "\"sllv\"", "\"sra\"", "\"srav\"", "\"srl\"",
  "\"srlv\"", "\"rol\"", "\"ror\"", "\"and\"", "\"andi\"", "\"or\"",
  "\"ori\"", "\"xor\"", "\"xori\"", "\"nor\"", "\"not\"", "\"seq\"",
  "\"sne\"", "\"sge\"", "\"sgeu\"", "\"sgt\"", "\"sgtu\"", "\"sle\"",
  "\"sleu\"", "\"slt\"", "\"sltu\"", "\"slti\"", "\"sltiu\"", "\"beq\"",
  "\"beqz\"", "\"bne\"", "\"bnez\"", "\"bge\"", "\"bgeu\"", "\"bgez\"",
  "\"bgezal\"", "\"bgt\"", "\"bgtu\"", "\"bgtz\"", "\"ble\"", "\"bleu\"",
  "\"blez\"", "\"blt\"", "\"bltu\"", "\"bltz\"", "\"bltzal\"", "\"j\"",
  "\"jal\"", "\"jr\"", "\"jalr\"", "\"lb\"", "\"lbu\"", "\"lw\"",
  "\"lui\"", "\"li\"", "\"la\"", "\"sb\"", "\"sw\"", "\"move\"",
  "\"mfhi\"", "\"mflo\"", "\"mthi\"", "\"mtlo\"", "\"mfc0\"", "\"mtc0\"",
  "\"syscall\"", "\"nop\"", "$accept", "program", "datas", "data",
  "instructions", "instruction", "exp", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  parser::yyrline_[] =
  {
       0,   191,   191,   192,   193,   198,   199,   203,   207,   211,
     214,   217,   219,   222,   224,   229,   230,   234,   238,   244,
     249,   254,   258,   264,   269,   274,   278,   283,   287,   292,
     296,   302,   307,   312,   318,   323,   328,   333,   337,   342,
     346,   351,   355,   361,   366,   371,   376,   382,   387,   392,
     398,   403,   409,   414,   420,   425,   430,   434,   440,   445,
     451,   456,   461,   465,   471,   476,   482,   487,   492,   496,
     502,   507,   513,   518,   524,   529,   534,   538,   544,   549,
     554,   558,   564,   569,   574,   578,   583,   587,   593,   598,
     603,   607,   612,   616,   622,   627,   632,   636,   641,   645,
     651,   656,   661,   665,   670,   674,   680,   685,   690,   694,
     700,   705,   710,   714,   720,   725,   730,   734,   740,   745,
     750,   754,   760,   765,   769,   775,   780,   784,   790,   795,
     800,   804,   810,   815,   820,   824,   830,   835,   840,   844,
     850,   855,   860,   864,   869,   873,   878,   882,   887,   891,
     895,   900,   904,   908,   913,   917,   922,   926,   930,   934,
     939,   943,   948,   952,   956,   961,   965,   970,   974,   978,
     983,   987,   992,   996,  1000,  1004,  1007,  1010,  1014,  1018,
    1023,  1028,  1033,  1038,  1043,  1048,  1052,  1056,  1061,  1066,
    1070,  1075,  1080,  1085,  1090,  1095,  1099,  1103,  1107,  1111,
    1116,  1121,  1124,  1129,  1130,  1131,  1132,  1133,  1135,  1136,
    1137
  };

  void
  parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  parser::symbol_kind_type
  parser::yytranslate_ (int t) YY_NOEXCEPT
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const signed char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104
    };
    // Last valid token kind.
    const int code_max = 359;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return static_cast <symbol_kind_type> (translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

} // yy
#line 3382 "./asm-parse.cc"

#line 1139 "asm-parse.yy"

void
yy::parser::error(const location &l, const std::string &msg)
{
  std::cerr << l << ": " << msg << std::endl;
  exit_set (exit_parse);
}

